diff --git a/SConstruct b/SConstruct
index 7e12d413..9c5e4afc 100755
--- a/SConstruct
+++ b/SConstruct
@@ -710,6 +710,10 @@ conf.check_sysmacro_h()
 if conf.env['HAVE_LIBELF']:
     conf.env.Append(_LIBFLAGS=['-lelf'])
 
+# NB: After checks so they don't fail
+conf.env.Append(CCFLAGS=['-Werror=undef'])
+
+
 if ARGUMENTS.get('GDB') == '1':
     ARGUMENTS['DEBUG'] = '1'
     ARGUMENTS['SYMBOLS'] = '1'
diff --git a/lib/config.h.in b/lib/config.h.in
index 30025171..b0c2d816 100644
--- a/lib/config.h.in
+++ b/lib/config.h.in
@@ -89,17 +89,20 @@
 #define LLI G_GINT64_FORMAT
 
 
+#include <stdint.h> /* for UINTPTR_MAX */
 #define RM_PLATFORM_32 (UINTPTR_MAX == 0xffffffff)
 #define RM_PLATFORM_64 (UINTPTR_MAX == 0xffffffffffffffff)
 
-#ifdef __APPLE__
-# ifdef __MACH__
-#  define RM_IS_APPLE 1
-# endif
+#if defined(__APPLE__) && defined(__MACH__)
+# define RM_IS_APPLE 1
+#else
+# define RM_IS_APPLE 0
 #endif
 
 #ifdef __CYGWIN__
 # define RM_IS_CYGWIN 1
+#else
+# define RM_IS_CYGWIN 0
 #endif
 
 #include <glib.h>
@@ -214,4 +217,6 @@ typedef guint64 RmOff;
     #define WARN_UNUSED_RESULT
 #endif
 
+#define _RM_OFFSET_DEBUG 0
+
 #endif
diff --git a/lib/hasher.c b/lib/hasher.c
index 58dbdf1c..09a7f214 100644
--- a/lib/hasher.c
+++ b/lib/hasher.c
@@ -32,20 +32,23 @@
 #include "hasher.h"
 #include "utilities.h"
 
-/* Flags for the fadvise() call that tells the kernel
- * what we want to do with the file.
- */
-const int HASHER_FADVISE_FLAGS = 0
-#ifdef POSIX_FADV_SEQUENTIAL
-                                 | POSIX_FADV_SEQUENTIAL /* Read from 0 to file-size    */
+#ifndef POSIX_FADV_SEQUENTIAL
+# define POSIX_FADV_SEQUENTIAL 0
 #endif
-#ifdef POSIX_FADV_WILLNEED
-                                 | POSIX_FADV_WILLNEED /* Tell the kernel to readahead */
+#ifndef POSIX_FADV_WILLNEED
+# define POSIX_FADV_WILLNEED 0
 #endif
-#ifdef POSIX_FADV_NOREUSE
-                                 | POSIX_FADV_NOREUSE /* We will not reuse old data  */
+#ifndef POSIX_FADV_NOREUSE
+# define POSIX_FADV_NOREUSE 0
 #endif
-    ;
+
+/* Flags for the fadvise() call that tells the kernel
+ * what we want to do with the file.
+ */
+#define HASHER_FADVISE_FLAGS 0                                 \
+    | POSIX_FADV_SEQUENTIAL /* Read from 0 to file-size     */ \
+    | POSIX_FADV_WILLNEED   /* Tell the kernel to readahead */ \
+    | POSIX_FADV_NOREUSE    /* We will not reuse old data   */
 
 #define DIVIDE_CEIL(n, m) ((n) / (m) + !!((n) % (m)))
 
diff --git a/lib/md-scheduler.c b/lib/md-scheduler.c
index 8a1baa38..918b56d5 100644
--- a/lib/md-scheduler.c
+++ b/lib/md-scheduler.c
@@ -25,6 +25,9 @@
 
 #include "md-scheduler.h"
 
+
+#define _RM_MDS_DEBUG 0
+
 /* How many milliseconds to sleep if we encounter an empty file queue.
  * This prevents a "starving" RmShredDevice from hogging cpu and cluttering up
  * debug messages by continually recycling back to the joiner.
diff --git a/lib/traverse.c b/lib/traverse.c
index d3d69256..8337407e 100644
--- a/lib/traverse.c
+++ b/lib/traverse.c
@@ -273,6 +273,11 @@ static void rm_traverse_convert_small_stat_buf(struct stat *fts_statp, RmStat *b
 
 #else
 
+// size_t is 32 bits on 32-bit platforms, stat64 uses a 64-bit type
+G_STATIC_ASSERT(G_SIZEOF_MEMBER(RmStat, st_size) == G_SIZEOF_MEMBER(__fts_stat_t, st_size));
+// ino_t is 32 bits on some 64-bit platforms, stat64 uses a 64-bit type
+G_STATIC_ASSERT(G_SIZEOF_MEMBER(RmStat, st_ino) == G_SIZEOF_MEMBER(__fts_stat_t, st_ino));
+
 #define ADD_FILE(lint_type, is_symlink) \
     _ADD_FILE(lint_type, is_symlink, (RmStat *)p->fts_statp)
 
diff --git a/lib/utilities.c b/lib/utilities.c
index 5eeadbf9..1874e7d1 100644
--- a/lib/utilities.c
+++ b/lib/utilities.c
@@ -983,8 +983,6 @@ bool rm_mounts_can_reflink(RmMountTable *self, dev_t source, dev_t dest) {
 
 #if HAVE_FIEMAP
 
-#define _RM_OFFSET_DEBUG 0
-
 /* Return fiemap structure containing n_extents for file descriptor fd.
  * Return NULL if errors encountered.
  * Needs to be freed with g_free if not NULL.
